﻿' * * * * * * * * * dbi technologies inc. * * * * * * * * * 
' * * * * * * *  xAIgent Sample application * * * * * * * *
' * * * * * * * * * * Copyright 2016  * * * * * * * * * * *

Public Class frmMain

    Private Sub ButtonRun_Click(sender As Object, e As EventArgs) Handles ButtonRun.Click
        Dim myxAIgentService As New xAIgentService.DBIXServiceClient    'Create an instance of the xAIgent restful service
        Dim myxAIgentRequest As New xAIgentService.ExtractionRequest    'Create an instance of the xAIgent request
        Dim myxAIgentResponse As New xAIgentService.ExtractionResult    'Create an instance of the xAIgent result
        myxAIgentRequest.ApplicationID = "xAIgent VB.NET sample"     'Set the application ID to identify the application calling the xAIgent service
        myxAIgentRequest.LanguageID = 0     'Set the language for the document to be extracted to Auto Detect.  NOTE: This does not work with Japanese or Korean
        myxAIgentRequest.NumberOfPhrasesToReturn = 5    'Set the number of phrases to return
        myxAIgentRequest.SubscriptionID = "Your Subscription ID"    'Set the Subscription ID for authentication to use the xAIgent service
        myxAIgentRequest.XTractionDocument = Me.TextBoxExtractee.Text   'Set the document for extraction to the text in the TextBoxExtractee text box

        Try

            myxAIgentResponse = myxAIgentService.GetExtraction(myxAIgentRequest)    'Run the xAIgent Service to extract the text and return the key phrases.

            Dim myResultsCounter As Integer = 1
            Me.TextBoxResults.Text = ""

            If myxAIgentResponse.KeyPhrases.Count > 0 Then

                'Process each key phrase object in the response.
                Dim keyPhrase2Process As xAIgentService.KeyPhrase

                For Each keyPhrase2Process In myxAIgentResponse.KeyPhrases

                    keyPhrase2Process.Phrase = keyPhrase2Process.Phrase.ToUpper
                    keyPhrase2Process.Highlight = keyPhrase2Process.Highlight.ToCharArray()

                    'Output the keyphrase object to the results text box.
                    Me.TextBoxResults.Text = Me.TextBoxResults.Text & myResultsCounter.ToString & ". " & keyPhrase2Process.Phrase & vbCrLf & "Score: " & keyPhrase2Process.Score.ToString & vbCrLf & "Highlight: " & keyPhrase2Process.Highlight & vbCrLf & vbCrLf

                    myResultsCounter = myResultsCounter + 1

                Next

            Else

                Me.TextBoxResults.Text = "No Results were returned."

            End If

        Catch ex As Exception

            Me.TextBoxResults.Text = ex.Message.ToString()

        End Try

    End Sub

    Private Sub ButtonGetTokenStatus_Click(sender As Object, e As EventArgs) Handles ButtonGetTokenStatus.Click

        'Create an instance of the xAIgent service.
        Dim myxAIgent As xAIgentService.DBIXServiceClient = New xAIgentService.DBIXServiceClient()
        'Create a TokenStatusRequest object.
        Dim myTokenStatusRequest As xAIgentService.TokenStatusRequest = New xAIgentService.TokenStatusRequest()
        'DEVELOPER NOTE: Set your Subscription ID as the Token2Inspect on the request.
        myTokenStatusRequest.Token2Inspect = "Your Subscription ID"

        Try

            'Use the GetTokenStatus method on the xAIgent service to return a TokenStatusResult object.
            Dim myRequestResult As xAIgentService.TokenStatusResult = myxAIgent.GetTokenStatus(myTokenStatusRequest)
            Dim messageLine1 As String = ""

            If (myRequestResult.TokenValid = 1) Then
                messageLine1 = "Token Valid"
            Else
                messageLine1 = "Token Not Valid"
            End If

            Dim tokenStatusDescription As String = ""

            Select Case myRequestResult.TokenStatus

                Case 1
                    tokenStatusDescription = "Token Active"
                Case 2
                    tokenStatusDescription = "Token Active Pending Auto Step"
                Case 3
                    tokenStatusDescription = "Token Active Period Maximum Reached"
                Case Else
                    tokenStatusDescription = "Token Inactive"
            End Select


            Dim messageLine2 As String = tokenStatusDescription
            Dim messageLine3 As String = "Days to Transaction Count Reset: " + myRequestResult.Days2Reset.ToString()
            Dim messageLine4 As String = "Period Maximum Transactions: " + myRequestResult.TransactionsMaximum.ToString()
            Dim messageLine5 As String = "Period Transactions Remaining: " + myRequestResult.TransactionsRemaining.ToString()

            MessageBox.Show(messageLine1 + Environment.NewLine + Environment.NewLine + messageLine2 + Environment.NewLine + Environment.NewLine + messageLine3 + Environment.NewLine + Environment.NewLine + messageLine4 + Environment.NewLine + Environment.NewLine + messageLine5, "Token Status")

        Catch ex As Exception

            MessageBox.Show("An Error occurred getting the token status ..." + Environment.NewLine + Environment.NewLine + ex.Message)

        End Try

    End Sub
End Class
